<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Installing openPASS &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../_static/css/custom.css?v=4ad39fc2" />
      <link rel="stylesheet" type="text/css" href="../_static/tabs.css?v=a5c4661c" />

  
    <link rel="shortcut icon" href="../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../_static/jquery.js?v=5d32c60e"></script>
        <script src="../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../_static/doctools.js?v=888ff710"></script>
        <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="../_static/tabs.js?v=3030b3cb"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Further Guidance" href="50_further_guidance.html" />
    <link rel="prev" title="Installing Prerequisites" href="20_install_prerequisites.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            openPASS
              <img src="../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Installing openPASS</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/installation_guide/30_install_openpass.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="installing-openpass">
<span id="download-and-install-openpass"></span><h1>Installing openPASS<a class="headerlink" href="#installing-openpass" title="Link to this heading"></a></h1>
<p>This section describes how to compile and run <strong>openPASS</strong>. Please make sure that all prerequisites have been properly installed according to section <a class="reference internal" href="20_install_prerequisites.html#prerequisites"><span class="std std-ref">Installing Prerequisites</span></a>.
If you have strictly followed the instructions, the installed dependencies should be located on your machine under
<code class="docutils literal notranslate"><span class="pre">C:\deps</span></code> on <strong>Windows</strong> and <code class="docutils literal notranslate"><span class="pre">~/deps</span></code> on <strong>Linux</strong>. If there is a path deviation,
the following commands must be adjusted.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If you are unfamiliar to <code class="docutils literal notranslate"><span class="pre">CMake</span></code> or working within a <code class="docutils literal notranslate"><span class="pre">MinGW</span> <span class="pre">64-bit</span></code> shell, Section <a class="reference internal" href="further_guidance/10_cmake.html#cmake"><span class="std std-ref">CMake Variables and Options</span></a> and <a class="reference internal" href="20_install_prerequisites.html#msys2"><span class="std std-ref">MSYS2</span></a> might give you a short introduction on these topics in the scope of building <strong>openPASS</strong> itself.</p>
</div>
<ol class="arabic">
<li><p>Navigate back into repository</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-0-0-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-0-0-0" name="0-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-0-0-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-0-0-1" name="0-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-0-0-0" class="sphinx-tabs-panel" id="panel-0-0-0" name="0-0" role="tabpanel" tabindex="0"><div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cd</span> <span class="o">/</span><span class="n">C</span><span class="o">/</span><span class="n">openpass</span>
</pre></div>
</div>
</div><div aria-labelledby="tab-0-0-1" class="sphinx-tabs-panel" hidden="true" id="panel-0-0-1" name="0-1" role="tabpanel" tabindex="0"><div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cd</span> <span class="o">~/</span><span class="n">openpass</span>
</pre></div>
</div>
</div></div>
</li>
<li><p>Create build directory and navigate into it</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">mkdir</span> <span class="n">build</span>
<span class="n">cd</span> <span class="n">build</span>
</pre></div>
</div>
</li>
<li><p>Prepare build</p>
<p><strong>openPASS</strong> links against shared libraries, which are located in the paths specified by <code class="docutils literal notranslate"><span class="pre">CMAKE_PREFIX_PATH</span></code>.
To be able to install <strong>openPASS</strong> with resolved dependencies, all libraries found under the paths have to be copied right next to the executable during the installation step.
This is done by setting <code class="docutils literal notranslate"><span class="pre">INSTALL_EXTRA_RUNTIME_DEPS=ON</span></code>. If you have followed the instructions strictly, no changes are necessary.</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-1-1-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-1-1-0" name="1-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-1-1-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-1-1-1" name="1-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-1-1-0" class="sphinx-tabs-panel" id="panel-1-1-0" name="1-0" role="tabpanel" tabindex="0"><div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cmake</span> <span class="o">-</span><span class="n">G</span> <span class="s2">&quot;MSYS Makefiles&quot;</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">CMAKE_PREFIX_PATH</span><span class="o">=</span><span class="s2">&quot;C:/deps/direct_deploy/fmilibrary;C:/deps/direct_deploy/open-simulation-interface;C:/deps/direct_deploy/protobuf;C:/deps/direct_deploy/protobuf-shared;C:/deps/direct_deploy/units;C:/deps/direct_deploy/mantleapi;C:/deps/direct_deploy/yase;C:/deps/direct_deploy/openscenario_api;C:/deps/direct_deploy/openscenario_engine;C:/deps/direct_deploy/gtest;C:/deps/direct_deploy/boost;C:/deps/direct_deploy/minizip;C:/deps;C:/msys64/mingw64/bin;&quot;</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">CMAKE_INSTALL_PREFIX</span><span class="o">=</span><span class="n">C</span><span class="p">:</span><span class="o">/</span><span class="n">openPASS</span><span class="o">/</span><span class="nb">bin</span><span class="o">/</span><span class="n">core</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">CMAKE_BUILD_TYPE</span><span class="o">=</span><span class="n">Release</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">USE_CCACHE</span><span class="o">=</span><span class="n">ON</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">WITH_DEBUG_POSTFIX</span><span class="o">=</span><span class="n">OFF</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">OPENPASS_ADJUST_OUTPUT</span><span class="o">=</span><span class="n">OFF</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">INSTALL_EXTRA_RUNTIME_DEPS</span><span class="o">=</span><span class="n">ON</span> \
<span class="o">..</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<ul class="simple">
<li><p>By specifying <code class="docutils literal notranslate"><span class="pre">INSTALL_EXTRA_RUNTIME_DEPS=ON</span></code>, runtime dependencies will be copied to the installation directory when running <code class="docutils literal notranslate"><span class="pre">make</span> <span class="pre">install</span></code>. This applies to all dependencies located in the paths specified in <code class="docutils literal notranslate"><span class="pre">CMAKE_PREFIX_PATH</span></code>.</p></li>
<li><p>Make sure that the path <code class="docutils literal notranslate"><span class="pre">C:/msys64/mingw64/bin</span></code> is the last path in the CMAKE_PREFIX_PATH. Otherwise cmake might find and use local versions of required libraries instead of the ones listed in the thirdparties folder.</p></li>
</ul>
</div>
</div><div aria-labelledby="tab-1-1-1" class="sphinx-tabs-panel" hidden="true" id="panel-1-1-1" name="1-1" role="tabpanel" tabindex="0"><div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">cmake</span> <span class="o">-</span><span class="n">D</span> <span class="n">CMAKE_PREFIX_PATH</span><span class="o">=</span><span class="s2">&quot;$HOME/deps/fmilibrary;$HOME/deps/open-simulation-interface;$HOME/deps/protobuf;$HOME/deps/protobuf-shared;$HOME/deps/units;$HOME/deps/mantleapi;$HOME/deps/yase;$HOME/deps/openscenario_api;$HOME/deps/openscenario_engine;$HOME/deps/gtest;$HOME/deps/boost;$HOME/deps/minizip;C:/deps&quot;</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">CMAKE_INSTALL_PREFIX</span><span class="o">=/</span><span class="n">usr</span><span class="o">/</span><span class="n">local</span><span class="o">/</span><span class="n">openPASS</span><span class="o">/</span><span class="nb">bin</span><span class="o">/</span><span class="n">core</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">CMAKE_BUILD_TYPE</span><span class="o">=</span><span class="n">Release</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">USE_CCACHE</span><span class="o">=</span><span class="n">ON</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">WITH_DEBUG_POSTFIX</span><span class="o">=</span><span class="n">OFF</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">OPENPASS_ADJUST_OUTPUT</span><span class="o">=</span><span class="n">OFF</span> \
<span class="o">-</span><span class="n">D</span> <span class="n">INSTALL_EXTRA_RUNTIME_DEPS</span><span class="o">=</span><span class="n">ON</span> \
<span class="o">..</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<ul class="simple">
<li><p>To install in the mentioned CMAKE_INSTALL_PREFIX path, create <code class="docutils literal notranslate"><span class="pre">openPASS</span></code> folder under <code class="docutils literal notranslate"><span class="pre">/usr/local</span></code> using <code class="docutils literal notranslate"><span class="pre">sudo</span> <span class="pre">mkdir</span> <span class="pre">/usr/local/openPASS</span></code>
And for the user to access the folder, modify the permissions using <code class="docutils literal notranslate"><span class="pre">sudo</span> <span class="pre">chown</span> <span class="pre">&lt;uesrname&gt;:&lt;username&gt;</span> <span class="pre">/usr/local/openPASS</span></code></p></li>
<li><p>By specifying <code class="docutils literal notranslate"><span class="pre">INSTALL_EXTRA_RUNTIME_DEPS=ON</span></code>, runtime dependencies will be copied to the installation directory when running <code class="docutils literal notranslate"><span class="pre">make</span> <span class="pre">install</span></code>. This applies to all dependencies located in the paths specified in <code class="docutils literal notranslate"><span class="pre">CMAKE_PREFIX_PATH</span></code>.</p></li>
<li><p>If you need to adjust paths and options based on your system and needs, you need to pay attention on quotations <code class="docutils literal notranslate"><span class="pre">&quot;</span> <span class="pre">&quot;</span></code>, when using it in console (see <a class="reference internal" href="further_guidance/10_cmake.html#cmake-prefix-path"><span class="std std-ref">CMAKE_PREFIX_PATH</span></a>).
And also you need to be careful with it when you configuring it under VSCode (see <a class="reference internal" href="../developer_information/ide_support/30_vscode.html#vscode"><span class="std std-ref">Working with Visual Studio Code</span></a>).</p></li>
</ul>
</div>
</div></div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>For a build that goes beyond the default settings, see <a class="reference internal" href="further_guidance/10_cmake.html#cmake"><span class="std std-ref">CMake Variables and Options</span></a> for more available variables and options that can be set.</p>
</div>
</li>
<li><p>Optional: Build and execute unit tests</p>
<p>Starting from <code class="docutils literal notranslate"><span class="pre">openpass/build</span></code>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">make</span> <span class="n">test</span> <span class="n">ARGS</span><span class="o">=</span><span class="s2">&quot;--output-on-failure -j3&quot;</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>ARGS is optional, but recommended.
Adjust parallel build flag <code class="docutils literal notranslate"><span class="pre">-j3</span></code> based on your system.</p>
</div>
</li>
<li><p>Build documentation</p>
<p>Starting from <code class="docutils literal notranslate"><span class="pre">openpass/build</span></code>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">make</span> <span class="n">doc</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Currently the documentation must be built before <strong>openPASS</strong> can be successfully installed if the CMake variable <cite>WITH_DOC=ON</cite> (default).</p>
</div>
</li>
<li><p>Build simulation core</p>
<p>Starting from <code class="docutils literal notranslate"><span class="pre">openpass/build</span></code>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">make</span> <span class="o">-</span><span class="n">j3</span> <span class="n">install</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Again, adjust parallel build flag <code class="docutils literal notranslate"><span class="pre">-j3</span></code> based on your system.</p>
</div>
</li>
</ol>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="20_install_prerequisites.html" class="btn btn-neutral float-left" title="Installing Prerequisites" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="50_further_guidance.html" class="btn btn-neutral float-right" title="Further Guidance" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>